/* de56d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b5 = 1.;
static integer c__2 = 2;
static integer c__3 = 3;
static integer c__56 = 56;

/* Subroutine */ int de56d_c(D_fp ff, D_fp fg, D_fp fr, doublereal *xn,
        doublereal *xk, doublereal *cn, doublereal *ck, integer *nx, 
        doublereal *x, logical *buldy, doublereal *hmin, doublereal *eps, 
        doublereal *p, doublereal *h__, doublereal *y, doublereal *dy, 
        integer *nx1, integer *ierr)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal), atan2(doublereal, doublereal),
            d_sign(doublereal *, doublereal *), cos(doublereal),
            sin(doublereal);

    /* Local variables */
    static integer nx1p1, i__, j;
    static doublereal r__;
    extern /* Subroutine */ int de54du_c(D_fp, D_fp, D_fp, integer *,
            doublereal *, doublereal *, doublereal *, doublereal *, 
            doublereal *, doublereal *, doublereal *, doublereal *, 
            doublereal *, integer *), utde13_c(integer *, integer *);
    static doublereal tetuv[3], ra[12], xk1, xn1;
    static integer ier1;
    static logical bul1;

    /* Parameter adjustments */
    --cn;
    --ck;
    --dy;
    --y;
    --x;

    /* Function Body */
    *ierr = 0;
    r__ = (*ff)(xn);
    r__ = (*fg)(xn);
    r__ = (*fr)(xn);
    r__ = cn[1] * cn[1] + cn[2] * cn[2];
    if (r__ == 0.) {
        goto L10;
    }
    tetuv[1] = cn[3] / sqrt(r__);
    if (ck[2] * ck[2] + ck[1] * ck[1] == 0.) {
        goto L11;
    }
    tetuv[0] = atan2(cn[2], cn[1]);
    if ((x[1] - *xk) * (x[1] - *xn) > 0.) {
        goto L12;
    }
    d__1 = *xk - *xn;
    *h__ = d_sign(h__, &d__1);
    d__1 = *xk - *xn;
    r__ = d_sign(&c_b5, &d__1);
    bul1 = FALSE_;
    xn1 = *xn;
    i__1 = *nx;
    for (i__ = 1; i__ <= i__1; ++i__) {
        xk1 = x[i__];
        if ((d__1 = (*xk - xk1) * r__) < 0.) {
            goto L1;
        } else if (d__1 == 0) {
            goto L2;
        } else {
            goto L3;
        }
L1:
        *ierr = 1;
        xk1 = *xk;
L2:
        *nx1 = i__;
        bul1 = TRUE_;
        if (i__ == *nx) {
            goto L3;
        }
        *ierr += 2;
L3:
        de54du_c((D_fp)ff, (D_fp)fg, (D_fp)fr, &c__2, &xn1, tetuv, &xk1, hmin,
                eps, p, h__, tetuv, ra, &ier1);
        if (ier1 == 65) {
            goto L13;
        }
        y[i__] = tetuv[0];
        dy[i__] = tetuv[1];
        if (bul1) {
            goto L5;
        }
        xn1 = xk1;
/* L4: */
    }
    *nx1 = *nx;
    de54du_c((D_fp)ff, (D_fp)fg, (D_fp)fr, &c__2, &xn1, tetuv, xk, hmin, eps,
            p, h__, tetuv, ra, &ier1);
    if (ier1 == 65) {
        goto L13;
    }
L5:
    xk1 = cos(tetuv[0]);
    r__ = sin(tetuv[0]);
    ra[0] = ck[1] * r__ - ck[2] * xk1;
    if (ra[0] == 0.) {
        goto L14;
    }
    tetuv[2] = (tetuv[1] * (ck[1] * xk1 + ck[2] * r__) - ck[3]) / ra[0];
    nx1p1 = *nx1 + 1;
    j = 1;
    if (! bul1) {
        goto L6;
    }
    ier1 = *nx1;
    j = 2;
    xk1 = sin(y[ier1]);
    r__ = cos(y[ier1]);
    y[ier1] = dy[ier1] * xk1 + tetuv[2] * r__;
    if (*buldy) {
        dy[ier1] = dy[ier1] * r__ - tetuv[2] * xk1;
    }
L6:
    xk1 = *xk;
    bul1 = FALSE_;
    i__1 = *nx1;
    for (i__ = j; i__ <= i__1; ++i__) {
        de54du_c((D_fp)ff, (D_fp)fg, (D_fp)fr, &c__3, &xk1, tetuv, &xn1, hmin,
                eps, p, h__, tetuv, ra, &ier1);
        if (ier1 == 65) {
            goto L15;
        }
        ier1 = nx1p1 - i__;
        tetuv[0] = y[ier1];
        tetuv[1] = dy[ier1];
        xk1 = sin(y[ier1]);
        r__ = cos(y[ier1]);
        y[ier1] = dy[ier1] * xk1 + tetuv[2] * r__;
        if (*buldy) {
            dy[ier1] = dy[ier1] * r__ - tetuv[2] * xk1;
        }
        if (bul1) {
            goto L6;
        }
        xk1 = xn1;
        if (ier1 != 1) {
            xn1 = x[ier1 - 1];
        }
/* L8: */
    }
    goto L16;
L10:
    *ierr = 65;
    goto L16;
L11:
    *ierr = 66;
    goto L16;
L12:
    *ierr = 67;
    goto L16;
L13:
    *ierr = 68;
    goto L16;
L14:
    *ierr = 69;
    goto L16;
L15:
    *ierr = 70;
L16:
    if (*ierr != 0) {
        utde13_c(ierr, &c__56);
    }
    return 0;
} /* de56d_c */
